Rails.application.routes.draw do

  locales = Site.first.in_use_locales rescue I18n.available_locales

  scope "(:locale)", locale: Regexp.new(locales.join("|")) do
   namespace :admin do
    resources :venue_managements do
      member do
        get 'export'
        get 'set_write_off'
        get 'venue_management_signup'
        get 'venue_management_item_content'
        get 'venue_management_signup_field'
        get 'venue_management_submission_field'
        get 'venue_management_invitings'
        get 'venue_management_memorabilias'
        get 'venue_management_bills'
        get 'venue_management_contracts'
        get 'print_pdf'
      end
    end
    resources :venue_management_items do
      collection do
        post 'delete_items'
      end
    end
    resources :venue_management_agreements
    resources :venue_management_signups
    resources :venue_management_item_contents
    resources :venue_management_invitings do
      collection do
        get 'export'
      end
    end
    resources :venue_management_memorabilias
    resources :venue_management_bills do
      collection do
        scope "(:id)" do
          get 'copy', to: 'venue_management_bills#copy'
        end
        get 'export'
      end
    end
    resources :venue_management_contracts do
      collection do
        post 'fetch_inviting'
        get 'export'
      end
    end
   end

    resources :venue_managements do
      collection do
        get ':slug_title-:uid', to: 'venue_managements#show'
        post 'con_login_proc', to: 'venue_managements#con_login_proc'
        post 'con_logout_proc', to: 'venue_managements#con_logout_proc'
        post 'add_file_proc', to: 'venue_managements#add_file_proc'
        post 'edit_file_proc', to: 'venue_managements#edit_file_proc'
        post 'del_file', to: 'venue_managements#del_file'
      end
    end

  end

end
